#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <gui.h>

/*

Terceira Prova de Introduo  Programao C BCMT

Responda as questes abaixo programando as funes pedidas.
Voc  livre para criar funes auxiliares, e testar suas
funes usando o console ou a interface grfica.

A prova  individual, e com consulta livre. A durao da
prova  de duas horas.

*/

/* Questo 1 - 2,0 pontos */

/* Implemente a funo abaixo, que inverte a cadeia
de caracteres passada como parmetro sem precisar
criar uma nova cadeia, trocando o primeiro caractere
com o ltimo, o segundo com o penltimo etc. No
use a funo strrev. */

static void inverte(char *s) {
	/* implemente aqui */
}

/* Uma matriz de nmeros reais 
pode ser representada por uma estrutura
contendo o nmero de linhas e colunas e um vetor com
os elementos da matriz (esse vetor tem sempre tamanho
lins * cols): */

struct Matriz {
	int lins;
	int cols;
	double *nums;
};

/* A funo abaixo cria uma matriz com o nmero de linhas
e colunas pedido. */

static struct Matriz *matriz_cria(int lins, int cols) {
	struct Matriz *m = malloc(sizeof(struct Matriz));
	m->lins = lins;
	m->cols = cols;
	m->nums = malloc(lins * cols * sizeof(double));
	return m;
}

/* Questo 2 - 3,0 pontos */

/* Implemente a funo abaixo, que multiplica duas matrizes
e retorna uma terceira matriz. O nmero de linhas de m2
deve ser igual ao nmero de colunas de m1, e a matriz
resultante tem o nmero de linhas de m1 e o nmero de colunas
de m2. 

  m1m2(i,j) = m1(i,0) * m2(0, j) + 
              m1(i, 1) * m2(1, j) + 
			  ... +
			  m1(i, m1->cols) * m2(m2->lins, j)

 */

static struct Matriz *matriz_mult(struct Matriz *m1, struct Matriz *m2) {
	/* implemente aqui */
}


/* Uma rvore binria  uma estrutura recursiva em
que cada parte  composta de um "rtulo" e dois ramos,
o ramo esquerdo e o ramo direito. Cada ramo pode ser
0 ou apontar para uma rvore binria.

Se ambos os ramos de uma rvore so 0 dizemos que ela
 uma "folha". */

struct ArvBin {
	char *rot; /* string */
	struct ArvBin *esq;
	struct ArvBin *dir;
}; 

/* A funo abaixo imprime o contedo de uma rvore,
usando parnteses: (rotulo ramo-esq ramo-dir). Use
para depurao de suas funes. */

static void imprime_arvore(struct ArvBin *arv) {
	printf("(%s", arv->rot);
	if(arv->esq) {
		printf(" ");
		imprime_arvore(arv->esq);
	}
	if(arv->dir) {
		printf(" ");
		imprime_arvore(arv->dir);
	}
	printf(")");
}

/* A funo abaixo que cria uma nova rvore
dado seu rtulo e seus ramos esquerdo e direito. */

static struct ArvBin *cria_arvore(char *rot, struct ArvBin *esq, struct ArvBin *dir) {
	struct ArvBin *arv = malloc(sizeof(struct ArvBin));
	arv->rot = rot;
	arv->esq = esq;
	arv->dir = dir;
	return arv;
}

/* Questo 3 (3,0 pontos) */

/* Implemente a funo, que desenha *apenas a raiz* de uma rvore
como um retngulo preto com uma borda branca de dois pixels de largura.
O espao entre o texto do rtulo e as bordas do retngulo deve ser de cinco
pixels. As coordenadas x e y dadas so as do canto superior esquerdo
do retngulo. O texto do rtulo sempre tem 39 pixels de altura,
e a largura  de 24 pixels por caractere do texto. */

static void desenha_raiz(struct ArvBin *arv, int x, int y) {
	/* implemente aqui */
}

/* Questo 4 - 2,0 pontos */

/* Implemente a funo abaixo, que desenha a rvore inteira.
A posio x dada  a do centro horizontal da raiz, 
e a posio y dada  a do lado superior:

               X
      Y +-------------+
        | Rotulo Raiz |
        +-------------+

Use a funo da questo 2 para desenhar a raiz.
O ramo esquerdo deve ser desenhado com centro horizontal 100 pixels
 esquerda do *lado esquerdo* da raiz e lado superior
100 pixels abaixo do *lado inferior* da raiz. O ramo direito
deve ser desenhado com centro horizontal 100 pixels  direita
do lado direito da raiz e lado superior 100 pixels abaixo do 
lado inferior da raiz. */

static void desenha_arvore(struct ArvBin *arv, int x, int y) {
	/* implemente aqui */
}

/* Fim das questes */

void gui_init(String *titulo, int *largura, int *altura) {
	*titulo = "Terceira Prova de IntroC BCMT";
	*largura = 1024;
	*altura = 768;
	/* Esse  um bom lugar para testar funes que
	podem ser testadas no console, usando scanf e printf */
}

void gui_tecla(String tecla, int soltou) {
}

void gui_tique(double dt) {
}

void gui_mouse(int x, int y, int botao, int soltou) {
}

void gui_desenhar() {
	tela_texto(10, 10, "Terceira Prova Introc", 1.0, 1.0, 1.0);
}

